﻿@{
    ViewBag.Title = "Risk Register";
    Layout = "~/Views/Shared/_FixedLayout.cshtml";
}

<link href="~/Content/plugins/bootstrap-datepicker/css/bootstrap-datepicker.css" rel="stylesheet" />
<script src="~/Content/plugins/bootstrap-datepicker/js/bootstrap-datepicker.js"></script>
<link href="~/Content/plugins/bootstrap-combobox/css/bootstrap-combobox.css" rel="stylesheet" />
<script src="~/Content/plugins/bootstrap-combobox/js/bootstrap-combobox.js"></script>

<link href="~/Content/plugins/datatables/css/dataTables.bootstrap.css" rel="stylesheet" />
<script src="~/Content/plugins/datatables/js/jquery.dataTables.min.js"></script>
<script src="~/Content/plugins/datatables/js/jquery.dataTables.columnFilter.js"></script>
<script src="~/Content/plugins/datatables/js/dataTables.bootstrap.js"></script>

<script type="text/javascript">


    var oTable;

    function loadOverall() {
        return $.ajax({
            url: '@Url.Action("GetOverall", "RiskRegister")',
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $('#ddlihrrisk_overallinherrisk').append('<option value="0">All</option>');
                $('#ddlresrisk_overallresidual').append('<option value="0">All</option>');
                $('#ddlexprisk_overallexpected').append('<option value="0">All</option>');

                $.each(results, function (i, result) {
                    $('#ddlihrrisk_overallinherrisk').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                    $('#ddlresrisk_overallresidual').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                    $('#ddlexprisk_overallexpected').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlihrrisk_overallinherrisk').append('<option value="">No data found</option>');
                $('#ddlresrisk_overallresidual').append('<option value="">No data found</option>');
                $('#ddlexprisk_overallexpected').append('<option value="">No data found</option>');
            }
        });
    }

    function loadStatus() {
        return $.ajax({
            url: '@Url.Action("GetStatus", "RiskRegister")',
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $('#ddlstatus').append('<option value="0">All</option>');
                $.each(results, function (i, result) {
                    $('#ddlstatus').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlstatus').append('<option value="">No data found</option>');
            }
        });
    }

    function loadDivision() {
        //alert('loadDivision');
        return $.ajax({
            url: '@Url.Action("GetDivList", "RiskRegister")',
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $('#ddlDivision').append('<option value="0">All</option>');
                $.each(results, function (i, result) {
                    $('#ddlDivision').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                    $('#ddlDivision2').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlDivision').append('<option value="">No data found</option>');
                $('#ddlDivision2').append('<option value="">No data found</option>');
            }
        });
    }

    function loadDepartment() {
        //alert('loadDepartment');
        return $.ajax({
            url: '@Url.Action("GetDeptListbyDivId", "RiskRegister")?divid=' + $('#ddlDivision').val(),
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $('#ddlDepartment').empty();
                $('#ddlDepartment').append('<option value="0">All</option>');
                $.each(results, function (i, result) {
                    $('#ddlDepartment').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
                if (localStorage.getItem("ddlDivision") != null) {
                    document.getElementById("ddlDepartment").value = localStorage.getItem("ddlDepartment");
                }
            },
            error: function (ex) {
                $('#ddlDepartment').append('<option value="">No data found</option>');
            }
        });
    }

    function loadDepartment2() {

        return $.ajax({
            url: '@Url.Action("GetDeptListbyDivId", "RiskRegister")?divid=' + $('#ddlDivision2').val(),
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $('#ddlDepartment2').empty();
                $.each(results, function (i, result) {
                    $('#ddlDepartment2').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlDepartment2').append('<option value="">No data found</option>');
            }
        });
    }

    function loadFinancialImpact() {
        return $.ajax({
            url: '@Url.Action("GetFinancialImpact", "RiskRegister")',
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $('#ddlihrrisk_finimpact').append('<option value="0">All</option>');
                $.each(results, function (i, result) {
                    $('#ddlihrrisk_finimpact').append('<option value="' + result.Value + '">' + result.Text + '</option>');

                });
            },
            error: function (ex) {
                $('#ddlihrrisk_finimpact').append('<option value="">No data found</option>');

            }
        });
    }

    function loadOperationalImpact() {
        return $.ajax({
            url: '@Url.Action("GetOperationImpact", "RiskRegister")',
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $('#ddlihrrisk_oprimpact').append('<option value="0">All</option>');
                $.each(results, function (i, result) {
                    $('#ddlihrrisk_oprimpact').append('<option value="' + result.Value + '">' + result.Text + '</option>');

                });
            },
            error: function (ex) {
                $('#ddlihrrisk_oprimpact').append('<option value="">No data found</option>');

            }
        });
    }

    function loadStrategicImpact() {
        return $.ajax({
            url: '@Url.Action("GetStrategicImpact", "RiskRegister")',
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $('#ddlihrrisk_qualitativeimpact').append('<option value="0">All</option>');

                $.each(results, function (i, result) {
                    $('#ddlihrrisk_qualitativeimpact').append('<option value="' + result.Value + '">' + result.Text + '</option>');

                });
            },
            error: function (ex) {
                $('#ddlihrrisk_qualitativeimpact').append('<option value="">No data found</option>');

            }
        });
    }


    function DownloadFile() {
        window.location.href = '@Url.Action("DownloadFile", "RiskRegister")?divid=' + $('#ddlDivision').val() + '&deptid=' + $('#ddlDepartment').val() + '&status=' + $('#ddlstatus').val() + '&ihrrisk_overallinherrisk=' + $('#ddlihrrisk_overallinherrisk').val() + '&resrisk_overallresidual=' + $('#ddlresrisk_overallresidual').val() + '&exprisk_overallexpected=' + $('#ddlexprisk_overallexpected').val();
    }

    function DownloadDelFile() {
        window.location.href = '@Url.Action("DownloadDelFile", "RiskRegister")';
    }

    function loadData() {
        //alert('loaddata');
        if (oTable != null) {
            oTable.fnDestroy();
        }


        var aryColTableChecked = [];
        for (var idx = 1; idx < 28; idx++) {
            aryColTableChecked.push("field" + idx);

        }

        var aoColumnDef = [];

        $.each(aryColTableChecked, function (i, value) {

            var obj = {
                "mData": value, "aTargets": [i]
            }
            if (i == 0) {
                obj = {
                    "mData": value,
                    "aTargets": [i],
                    "mRender": function (data, type, row) {
                        return '<input type="checkbox" name="chkRow" class="text-center row-select" aria-label="' + data + '" title="Select this">';
                    },
                    "bSortable": false
                }
            } else if (i == 1) {

                var obj = {
                    "mData": value,
                    "aTargets": [i],
                    "mRender": function (data, type, row) {
                        if ('@ViewBag.Delete' == "1") {
                            return '<a class="btn btn-primary btn-xs tblButton" style="width: 30px;" name="btnEdit" aria-label="Edit" data-id="' + data + '" ><i class="glyphicon glyphicon-pencil"></i></a>' +
                                '&nbsp;<a class="btn btn-primary btn-xs tblButton" style="width: 30px;" name = "btnDelete" aria-label="Delete" data-id="' + data + '" ><i class="glyphicon glyphicon-trash"></i></a>';
                        } else {
                            return '<a class="btn btn-primary btn-xs tblButton" style="width: 30px;" name="btnEdit" aria-label="Edit" data-id="' + data + '" ><i class="glyphicon glyphicon-pencil"></i></a>';
                        }



                    },
                    "bSortable": false
                }
            }
            aoColumnDef.push(obj);
        });


        oTable = $('#tblData').dataTable({
            "sAjaxSource": "@Url.Action("GetRiskRegisterList", "RiskRegister")",
            "bServerSide": false,
            "bProcessing": true,
            "bSort": false,
            "bPaginate": true,
            "scrollX": true,
            "bLengthChange": false,
            "bStateSave": false,
            "bDestroy": true,
            "bRetrieve": true,
            "fnServerData": function (sSource, aoData, fnCallback) {
                $.ajax({
                    "dataType": "json",
                    "type": "POST",
                    "url": sSource,
                    "data": aoData,
                    "success": fnCallback
                });
            },
            "sDom": '<"#tblData_header.clearfix "<"pull-left"l><"pull-right"r>><"table-responsive"t><"#ScrollTop"><"#tblData_footer.clearfix "<"pull-left"i><"pull-right"p>>',
            "fnServerParams": function (aoData) {
                aoData.push({ "name": "divid", "value": $('#ddlDivision').val() });
                aoData.push({ "name": "deptid", "value": $('#ddlDepartment').val() });
                aoData.push({ "name": "status", "value": $('#ddlstatus').val() });
                aoData.push({ "name": "ihrrisk_overallinherrisk", "value": $('#ddlihrrisk_overallinherrisk').val() });
                aoData.push({ "name": "resrisk_overallresidual", "value": $('#ddlresrisk_overallresidual').val() });
                aoData.push({ "name": "exprisk_overallexpected", "value": $('#ddlexprisk_overallexpected').val() });

                aoData.push({ "name": "departmentkpi", "value": $('#txtdepartmentkpi').val() });
                aoData.push({ "name": "riskdesc_loss", "value": $('#txtriskdesc_loss').val() });
                aoData.push({ "name": "riskdesc_caused", "value": $('#txtriskdesc_caused').val() });
                aoData.push({ "name": "ihrrisk_notes", "value": $('#txtihrrisk_notes').val() });
                aoData.push({ "name": "ihrrisk_finimpact", "value": $('#ddlihrrisk_finimpact').val() });
                aoData.push({ "name": "ihrrisk_oprimpact", "value": $('#ddlihrrisk_oprimpact').val() });
                aoData.push({ "name": "ihrrisk_qualitativeimpact", "value": $('#ddlihrrisk_qualitativeimpact').val() });
                aoData.push({ "name": "curraction_controldesc", "value": $('#txtcurraction_controldesc').val() });
                aoData.push({ "name": "resrisk_notes", "value": $('#txtresrisk_notes').val() });
                aoData.push({ "name": "exprisk_treatplan", "value": $('#txtexprisk_treatplan').val() });
                aoData.push({ "name": "exprisk_schedule", "value": $('#txtexprisk_schedule').val() });

            },
            "aoColumns": [
                { "sWidth": "50px" },
                { "sWidth": "100px" },
                { "sWidth": "50px" },
                { "sWidth": "150px" },
                { "sWidth": "100px" },
                { "sWidth": "150px" },
                { "sWidth": "200px" },
                { "sWidth": "200px" },
                { "sWidth": "200px" },
                { "sWidth": "100px" },
                { "sWidth": "100px" },
                { "sWidth": "100px" },
                { "sWidth": "100px" },
                { "sWidth": "100px" },
                { "sWidth": "100px" },
                { "sWidth": "200px" },
                { "sWidth": "200px" },
                { "sWidth": "100px" },
                { "sWidth": "100px" },
                { "sWidth": "100px" },
                { "sWidth": "200px" },
                { "sWidth": "100px" },
                { "sWidth": "100px" },
                { "sWidth": "100px" },
                
                { "sWidth": "100px" }
            ]
        ,
            "aoColumnDefs": aoColumnDef,
            "iDisplayLength": 10,
            "oLanguage": {
                "sProcessing": '<i class="fa fa-spinner fa-spin"></i> Retrieve Data ... ',
                "sLengthMenu": '_MENU_'
            },
        });

        oTable.fnSettings().aoColumns[0].sClass = "text-center";
        oTable.fnSettings().aoColumns[1].sClass = "text-center";
        oTable.fnSettings().aoColumns[2].sClass = "text-center";
        oTable.fnSettings().aoColumns[3].sClass = "text-center";
        oTable.fnSettings().aoColumns[4].sClass = "text-left";
        oTable.fnSettings().aoColumns[5].sClass = "text-left";
        oTable.fnSettings().aoColumns[6].sClass = "text-center";
        oTable.fnSettings().aoColumns[7].sClass = "text-left";
        oTable.fnSettings().aoColumns[8].sClass = "text-center";
        oTable.fnSettings().aoColumns[9].sClass = "text-center";
        oTable.fnSettings().aoColumns[10].sClass = "text-center";
        oTable.fnSettings().aoColumns[11].sClass = "text-center";
        oTable.fnSettings().aoColumns[12].sClass = "text-center";
        oTable.fnSettings().aoColumns[13].sClass = "text-center";
        oTable.fnSettings().aoColumns[14].sClass = "text-left";
        oTable.fnSettings().aoColumns[15].sClass = "text-left";
        oTable.fnSettings().aoColumns[16].sClass = "text-center";
        oTable.fnSettings().aoColumns[17].sClass = "text-center";
        oTable.fnSettings().aoColumns[18].sClass = "text-center";
        oTable.fnSettings().aoColumns[19].sClass = "text-left";
        oTable.fnSettings().aoColumns[20].sClass = "text-center";
        oTable.fnSettings().aoColumns[21].sClass = "text-center";
        oTable.fnSettings().aoColumns[22].sClass = "text-center";
        oTable.fnSettings().aoColumns[23].sClass = "text-center";
        oTable.fnSettings().aoColumns[24].sClass = "text-center";

      
        $('#tblData tbody').on('click', 'a', function () {

            var table = $('#tblData').DataTable();
            var row = table.row($(this).parents('tr')).data();
            var action = $(this).attr('aria-label');
            //var rowid = $(this).attr('data-id');
            var rowid = row['field1'].split("#")[0];
            var status = row['field25'].split("#")[0];


            if (action == 'Edit') {

                if (status == "Pending Approval") {
                    window.location.href = '@Url.Action("EditRiskRegisterApprover", "RiskRegister")?id=' + rowid;
                @*} else if (status == "Approved") {
                    window.location.href = '@Url.Action("EditRiskRegisterDisabled", "RiskRegister")?id=' + rowid;*@
                }
                else {
                    window.location.href = '@Url.Action("EditRiskRegister", "RiskRegister")?id=' + rowid;
                }



            }
            if (action == 'Delete') {
                bootbox.confirm({
                    title: "<i class='fa fa-warning fa-2x'></i> Delete Confirmation",
                    message: 'Are you sure you want to delete this data.',
                    className: "medium",
                    buttons: {
                        'cancel': {
                            label: '<i class="fa fa-times"></i> Cancel',
                            className: 'btn-default pull-left'
                        },
                        'confirm': {
                            label: '<i class="fa fa-check"></i> Yes, Continue delete',
                            className: 'btn-primary pull-right'
                        }
                    },
                    callback: function (result) {
                        if (result) {
                            var url = '@Url.Action("DeleteRiskRegister", "RiskRegister")?rowid=' + rowid;
                            $.ajax(url, {
                                contentType: 'application/json; charset=utf-8',
                                dataType: 'json',
                                type: 'POST',
                                success: function (data) {
                                    bootbox.dialog({
                                        message: data.message,
                                        title: data.title,
                                        buttons: {
                                            main: {
                                                label: "<i class='fa fa-check'></i> Ok",
                                                className: "btn-primary",
                                                callback: function () {
                                                    if (result) {
                                                        if (data.status) {
                                                            oTable.fnPageChange('first');
                                                            location.reload(true);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    });
                                },
                                error: function () {

                                }
                            });
                        }

                    }
                });
            }

        });


    }

    function saveLastState() {
        localStorage.setItem("ddlDivision", $('#ddlDivision').val());
        localStorage.setItem("ddlDepartment", $('#ddlDepartment').val());
        localStorage.setItem("ddlstatus", $('#ddlstatus').val());
        localStorage.setItem("ddlihrrisk_overallinherrisk", $('#ddlihrrisk_overallinherrisk').val());
        localStorage.setItem("ddlresrisk_overallresidual", $('#ddlresrisk_overallresidual').val());
        localStorage.setItem("ddlexprisk_overallexpected", $('#ddlexprisk_overallexpected').val());
        localStorage.setItem("txtdepartmentkpi", $('#txtdepartmentkpi').val());
        localStorage.setItem("txtriskdesc_loss", $('#txtriskdesc_loss').val());
        localStorage.setItem("txtriskdesc_caused", $('#txtriskdesc_caused').val());
        localStorage.setItem("txtihrrisk_notes", $('#txtihrrisk_notes').val());
        localStorage.setItem("ddlihrrisk_finimpact", $('#ddlihrrisk_finimpact').val());
        localStorage.setItem("ddlihrrisk_oprimpact", $('#ddlihrrisk_oprimpact').val());
        localStorage.setItem("ddlihrrisk_qualitativeimpact", $('#ddlihrrisk_qualitativeimpact').val());
        localStorage.setItem("txtcurraction_controldesc", $('#txtcurraction_controldesc').val());
        localStorage.setItem("txtresrisk_notes", $('#txtresrisk_notes').val());
        localStorage.setItem("txtexprisk_treatplan", $('#txtexprisk_treatplan').val());
        localStorage.setItem("txtexprisk_schedule", $('#txtexprisk_schedule').val());


    }

    function loadLastState() {
        if (localStorage.getItem("ddlDivision") != null) {
            document.getElementById("ddlDivision").value = localStorage.getItem("ddlDivision");
            loadDepartment();
            //document.getElementById("ddlDepartment").value = localStorage.getItem("ddlDepartment");
            document.getElementById("ddlstatus").value = localStorage.getItem("ddlstatus");
            document.getElementById("ddlihrrisk_overallinherrisk").value = localStorage.getItem("ddlihrrisk_overallinherrisk");
            document.getElementById("ddlresrisk_overallresidual").value = localStorage.getItem("ddlresrisk_overallresidual");
            document.getElementById("ddlexprisk_overallexpected").value = localStorage.getItem("ddlexprisk_overallexpected");
            document.getElementById("txtdepartmentkpi").value = localStorage.getItem("txtdepartmentkpi");
            document.getElementById("txtriskdesc_loss").value = localStorage.getItem("txtriskdesc_loss");
            document.getElementById("txtriskdesc_caused").value = localStorage.getItem("txtriskdesc_caused");
            document.getElementById("txtihrrisk_notes").value = localStorage.getItem("txtihrrisk_notes");
            document.getElementById("ddlihrrisk_finimpact").value = localStorage.getItem("ddlihrrisk_finimpact");
            document.getElementById("ddlihrrisk_oprimpact").value = localStorage.getItem("ddlihrrisk_oprimpact");
            document.getElementById("ddlihrrisk_qualitativeimpact").value = localStorage.getItem("ddlihrrisk_qualitativeimpact");
            document.getElementById("txtcurraction_controldesc").value = localStorage.getItem("txtcurraction_controldesc");
            document.getElementById("txtresrisk_notes").value = localStorage.getItem("txtresrisk_notes");
            document.getElementById("txtexprisk_treatplan").value = localStorage.getItem("txtexprisk_treatplan");
            document.getElementById("txtexprisk_schedule").value = localStorage.getItem("txtexprisk_schedule");
        }
    }

    $(document).ready(function () {
        loadFinancialImpact().then(loadOperationalImpact).then(loadStrategicImpact).then(loadStatus).then(loadOverall).then(loadDivision).then(loadDepartment).then(loadDepartment2).then(loadData).then(loadLastState);

        $("#loader").hide();
        $('.btn-file :file').on('fileselect', function (event, numFiles, label) {

            var input = $(this).parents('.input-group').find(':text'),
                log = numFiles > 1 ? numFiles + ' files selected' : label;

            if (input.length) {
                input.val(log);
            } else {
                if (log) alert(log);
            }

        });
        $(document).on('change', '.btn-file :file', function () {
            var input = $(this),
                numFiles = input.get(0).files ? input.get(0).files.length : 1,
                label = input.val().replace(/\\/g, '/').replace(/.*\//, '');
            input.trigger('fileselect', [numFiles, label]);
        });

        $("#btnDownloadTemplate").click(function (evt) {
            var CheckFile = '@Url.Action("CheckTemplateFile", "RiskRegister")';
            var getUrl = '@Url.Action("GetUrl", "RiskRegister")';
            $.ajax(CheckFile, {
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                type: 'POST',
                success: function (CheckFile) {
                    if (CheckFile.success) {
                        window.location = getUrl;
                    }
                },
                error: function () {

                }
            });
        });

        $("#btnUpload").click(function (evt) {
            //Do Validation
            if ($('#file').val() == "") {
                bootbox.alert("<i class='fa fa-warning fa-2x'></i> Please browse Risk File, this field is mandatory", function () {
                    setTimeout(function () { $('#file').focus(); }, 500);
                });
            } else if ($('#file').size > 1048576) {
                bootbox.alert("<i class='fa fa-warning fa-2x'></i> File must be smaller than 1MB", function () {
                    setTimeout(function () { $('#file').focus(); }, 500);
                });
            } else if ($('#file').val().substring(($('#file').val().lastIndexOf('.')) + 1, $('#file').val().length) != "xls") {
                bootbox.alert("<i class='fa fa-warning fa-2x'></i> File extension is invalid, please use .xls", function () {
                    setTimeout(function () { $('#file').focus(); }, 500);
                });
            } else {
                //confirmation
                bootbox.confirm({
                    title: "<i class='fa fa-warning fa-2x'></i> Upload Confirmation",
                    message: 'Are you sure you want to upload this file. <br>If not, click Cancel',
                    buttons: {
                        'cancel': {
                            label: '<i class="fa fa-times"></i> Cancel',
                            className: 'btn-default pull-left'
                        },
                        'confirm': {
                            label: '<i class="fa fa-check"></i> Yes, Continue upload',
                            className: 'btn-primary pull-right'
                        }
                    },
                    callback: function (result) {
                        if (result) {
                            //Start upload process
                            var formData = new FormData();
                            var file = document.getElementById("file").files[0];

                            formData.append("postedFileBase", file);
                            formData.append("deptid", $('#ddlDepartment2').val());

                            $.ajax({
                                type: "POST",
                                url: '@Url.Action("UploadFile", "RiskRegister")',
                                data: formData,
                                dataType: 'json',
                                contentType: false,
                                processData: false,
                                beforeSend: function () {
                                    $("#loader").show();
                                    $('#btnUpload').addClass('disabled');
                                    $('#btnDownloadTemplate').addClass('disabled');
                                    $('#file').addClass('disabled');
                                },
                                success: function (data) {
                                    $("#loader").hide();
                                    $('#btnUpload').removeClass('disabled');
                                    $('#btnDownloadTemplate').removeClass('disabled');
                                    $('#file').removeClass('disabled');
                                    bootbox.dialog({
                                        message: data.message,
                                        title: data.title,
                                        buttons: {
                                            main: {
                                                label: "<i class='fa fa-check'></i> Ok",
                                                className: "btn-primary",
                                                callback: function () {
                                                    if (result) {
                                                        if (data.status) {
                                                            location.reload(true);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    });

                                }
                            });
                        }
                    }
                });
            }

        });


        $("#btnSearch").click(function () {
            saveLastState();
            loadData();
        });

        $("#btnSubmitRegister").click(function () {

            var isSuccess = true;
            var n = 0;

            //validation
            var rows = $("#tblData").dataTable().fnGetNodes();
            for (var i = 0; i < rows.length; i++) {
                if ($(rows[i]).find('input[name="chkRow"]').is(':checked')) {
                    n++;

                    var rowid = $(rows[i]).find("input[name='chkRow']").attr('aria-label'); //rowid


                    //validate data
                    if ($(rows[i]).find('td:eq(24)').html() != 'Complete') {
                        bootbox.alert("<i class='fa fa-warning fa-2x'></i> Please make sure only data with status complete can be submit");
                        isSuccess = false;
                        return false;
                    }

                }
            }


            //no record selected
            if (isSuccess == true && n == 0) {
                isSuccess = false;
                bootbox.alert("<i class='fa fa-warning fa-2x'></i> Please select one or more record");
            }

            if (isSuccess) {
                //confirmation
                bootbox.confirm({
                    title: "<i class='fa fa-warning fa-2x'></i> Submit Confirmation",
                    message: 'Are you sure you want to submit this Data. <br>If not, click Cancel',
                    buttons: {
                        'cancel': {
                            label: '<i class="fa fa-times"></i> Cancel',
                            className: 'btn-default pull-left'
                        },
                        'confirm': {
                            label: '<i class="fa fa-check"></i> Yes, Continue submit',
                            className: 'btn-primary pull-right'
                        }
                    },
                    callback: function (result) {
                        if (result) {
                            var RiskRegisterList = [];
                            var rows = $("#tblData").dataTable().fnGetNodes();
                            for (var i = 0; i < rows.length; i++) {
                                var obj = {};
                                if ($(rows[i]).find('input[name="chkRow"]').is(':checked')) {
                                    obj['rowid'] = $(rows[i]).find("input[name='chkRow']").attr('aria-label');
                                    RiskRegisterList.push(obj);
                                }

                            }
                            var formData = new FormData();
                            formData.append("RiskRegisterList", JSON.stringify(RiskRegisterList));
                            $.ajax({
                                type: "POST",
                                url: '@Url.Action("SubmitRiskRegister", "RiskRegister")',
                                data: formData,
                                dataType: 'json',
                                contentType: false,
                                processData: false,
                                beforeSend: function () {

                                },
                                success: function (data) {

                                    bootbox.dialog({
                                        message: data.message,
                                        title: data.title,
                                        buttons: {
                                            main: {
                                                label: "<i class='fa fa-check'></i> Ok",
                                                className: "btn-primary",
                                                callback: function () {
                                                    if (result) {
                                                        if (data.status) {
                                                            location.reload(true);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    });


                                }
                            });
                        }
                    }
                });
            }

        });

        $("#btnApprove").click(function () {

            var isSuccess = true;
            var n = 0;

            //validation
            var rows = $("#tblData").dataTable().fnGetNodes();
            for (var i = 0; i < rows.length; i++) {
                if ($(rows[i]).find('input[name="chkRow"]').is(':checked')) {
                    n++;

                    var rowid = $(rows[i]).find("input[name='chkRow']").attr('aria-label'); //
                    //alert(rowid);
                    //validate data
                    if ($(rows[i]).find('td:eq(24)').html() != 'Pending Approval') {
                        bootbox.alert("<i class='fa fa-warning fa-2x'></i> Please make sure only data with status Pending Approval can be Approve");
                        isSuccess = false;
                        return false;
                    }
                }
            }


            //no record selected
            if (isSuccess == true && n == 0) {
                isSuccess = false;
                bootbox.alert("<i class='fa fa-warning fa-2x'></i> Please select one or more record");
            }

            if (isSuccess) {
                //confirmation
                bootbox.confirm({
                    title: "<i class='fa fa-warning fa-2x'></i> Submit Confirmation",
                    message: 'Are you sure you want to Approve this data. <br>If not, click Cancel',
                    buttons: {
                        'cancel': {
                            label: '<i class="fa fa-times"></i> Cancel',
                            className: 'btn-default pull-left'
                        },
                        'confirm': {
                            label: '<i class="fa fa-check"></i> Yes, Continue submit',
                            className: 'btn-primary pull-right'
                        }
                    },
                    callback: function (result) {
                        if (result) {
                            var RiskRegisterList = [];
                            var rows = $("#tblData").dataTable().fnGetNodes();
                            for (var i = 0; i < rows.length; i++) {
                                var obj = {};
                                if ($(rows[i]).find('input[name="chkRow"]').is(':checked')) {
                                    obj['rowid'] = $(rows[i]).find("input[name='chkRow']").attr('aria-label');
                                    RiskRegisterList.push(obj);
                                }

                            }
                            var formData = new FormData();
                            formData.append("RiskRegisterList", JSON.stringify(RiskRegisterList));
                            $.ajax({
                                type: "POST",
                                url: '@Url.Action("ApproveRiskRegister", "RiskRegister")',
                                data: formData,
                                dataType: 'json',
                                contentType: false,
                                processData: false,
                                beforeSend: function () {

                                },
                                success: function (data) {

                                    bootbox.dialog({
                                        message: data.message,
                                        title: data.title,
                                        buttons: {
                                            main: {
                                                label: "<i class='fa fa-check'></i> Ok",
                                                className: "btn-primary",
                                                callback: function () {
                                                    if (result) {
                                                        if (data.status) {
                                                            location.reload(true);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    });


                                }
                            });
                        }
                    }
                });
            }

        });

        $("#btnReset").click(function () {

            document.getElementById("ddlstatus").value = "0";
            document.getElementById("ddlDivision").value = "0";
            document.getElementById("ddlDepartment").value = "0";
            document.getElementById("ddlihrrisk_overallinherrisk").value = "0";
            document.getElementById("ddlresrisk_overallresidual").value = "0";
            document.getElementById("ddlexprisk_overallexpected").value = "0";

            document.getElementById("txtdepartmentkpi").value = "";
            document.getElementById("txtriskdesc_loss").value = "";
            document.getElementById("txtriskdesc_caused").value = "";
            document.getElementById("txtihrrisk_notes").value = "";
            document.getElementById("ddlihrrisk_finimpact").value = "0";
            document.getElementById("ddlihrrisk_oprimpact").value = "0";
            document.getElementById("ddlihrrisk_qualitativeimpact").value = "0";
            document.getElementById("ddlihrrisk_overallinherrisk").value = "0";
            document.getElementById("txtcurraction_controldesc").value = "";
            document.getElementById("txtresrisk_notes").value = "";
            document.getElementById("txtexprisk_treatplan").value = "";
            document.getElementById("txtexprisk_schedule").value = "";
            saveLastState();
            loadData();
        });


        //Division
        $(document).on("change", '#ddlDivision', function (e) {

            loadDepartment();
        });
        //Division
        $(document).on("change", '#ddlDivision2', function (e) {

            loadDepartment2();
        });

        $("#btnDownload").click(function (evt) {
            DownloadFile();
        });

        $("#btnDownloadDel").click(function (evt) {
            DownloadDelFile();
        });

        $("#btnFilter").click(function () {

            var text = $('#btnFilter').html();

            if (text == 'More Filter') {
                $("#btnFilter").html('Less Filter');
            } else {
                $("#btnFilter").html('More Filter');
            }



        });

        $('.tblCheck').click(function () {
            var isChecked = $(this).hasClass('fa-check-square-o');
            if (isChecked) {
                $(this).removeClass('fa-check-square-o');
                $(this).addClass('fa-square-o');
                $('input.row-select').each(function () {
                    this.checked = false;
                });
            } else {
                $(this).removeClass('fa-square-o');
                $(this).addClass('fa-check-square-o');
                $('input.row-select').each(function () {
                    this.checked = true;
                });
            }



        });
    });





</script>

<style>
    .label-def-margin {
        margin-top: 10px;
    }

    div.dataTables_wrapper {
        width: 100%;
        margin: 0 auto;
    }
</style>


<div class="col-sm-12">


    <div class="panel panel-primary" style="margin-bottom: 0;">
        <div class="panel-heading">
            Search
        </div>
        <div class="panel-body">
            <div class="row">
                <!--Division-->
                <div class="col-sm-1"><label class="label-def-margin" for="ddlDivision">Division</label></div>
                <div class="col-sm-3">
                    <select class="form-control" id="ddlDivision"></select>
                </div>
                <div class="col-sm-1"><label class="label-def-margin" for="ddlDepartment">Department</label></div>
                <div class="col-sm-3">
                    <select class="form-control" id="ddlDepartment"></select>
                </div>
                <div class="col-sm-1"><label class="label-def-margin" for="ddlstatus">Status</label></div>
                <div class="col-sm-3"><select class="form-control" id="ddlstatus"></select></div>
            </div>
            <div class="row">
                <div class="col-sm-1"><label class="label-def-margin" for="ddlihrrisk_overallinherrisk">Overall Inherent Risk</label></div>
                <div class="col-sm-3"><select class="form-control" id="ddlihrrisk_overallinherrisk"></select></div>
                <div class="col-sm-1"><label class="label-def-margin" for="ddlresrisk_overallresidual">Overall Residual</label></div>
                <div class="col-sm-3"><select class="form-control" id="ddlresrisk_overallresidual"></select></div>
                <div class="col-sm-1"><label class="label-def-margin" for="ddlexprisk_overallexpected">Overall Expected</label></div>
                <div class="col-sm-3"><select class="form-control" id="ddlexprisk_overallexpected"></select></div>
            </div>
            <div class="row">
                <div class="col-sm-1"></div>
                <div class="col-sm-3"></div>
                <div class="col-sm-1"></div>
                <div class="col-sm-3"></div>
                <div class="col-sm-1"></div>
                <div class="col-sm-3" style="text-align :right;"><button class="btn btn-primary" data-toggle="collapse" id="btnFilter" style="padding-top: 0px;padding-bottom: 0px;padding-left: 0px;padding-right: 0px;font-style: italic;font-size: 10px;" data-target=" #additionalfilter">More Filter</button></div>
            </div>

            <div id="additionalfilter" class="collapse">
                <div class="row">
                    <div class="col-sm-1"><label class="label-def-margin" for="txtdepartmentkpi">Department KPI</label></div>
                    <div class="col-sm-3"><input class="form-control" type="text" id="txtdepartmentkpi" /></div>
                    <div class="col-sm-1"><label class="label-def-margin" for="txtriskdesc_loss">Risk Description Loss Event</label></div>
                    <div class="col-sm-3"><input class="form-control" type="text" id="txtriskdesc_loss" /></div>
                    <div class="col-sm-1"><label class="label-def-margin" for="txtriskdesc_caused">Risk Description Cause</label></div>
                    <div class="col-sm-3"><input class="form-control" type="text" id="txtriskdesc_caused" /></div>
                </div>
                <div class="row">
                    <div class="col-sm-1"><label class="label-def-margin" for="txtihrrisk_notes">Inherent Risk Notes</label></div>
                    <div class="col-sm-3"><input class="form-control" type="text" id="txtihrrisk_notes" /></div>
                    <div class="col-sm-1"><label class="label-def-margin" for="ddlihrrisk_finimpact">Inherent Risk Financial Impact</label></div>
                    <div class="col-sm-3"><select class="form-control" id="ddlihrrisk_finimpact"></select></div>
                    <div class="col-sm-1"><label class="label-def-margin" for="ddlihrrisk_oprimpact">Inherent Risk Operation Impact</label></div>
                    <div class="col-sm-3"><select class="form-control" id="ddlihrrisk_oprimpact"></select></div>
                </div>
                <div class="row">
                    <div class="col-sm-1"><label class="label-def-margin" for="ddlihrrisk_qualitativeimpact">Inherent Risk Strategic Impact</label></div>
                    <div class="col-sm-3"><select class="form-control" id="ddlihrrisk_qualitativeimpact"></select></div>
                    <div class="col-sm-1"><label class="label-def-margin" for="txtcurraction_controldesc">Current Action Control Description</label></div>
                    <div class="col-sm-3"><input class="form-control" type="text" id="txtcurraction_controldesc" /></div>
                    <div class="col-sm-1"><label class="label-def-margin" for="txtresrisk_notes">Residual Risk Notes</label></div>
                    <div class="col-sm-3"><input class="form-control" type="text" id="txtresrisk_notes" /></div>
                </div>
                <div class="row">
                    <div class="col-sm-1"><label class="label-def-margin" for="txtexprisk_treatplan">Treatment Plan</label></div>
                    <div class="col-sm-3"><input class="form-control" type="text" id="txtexprisk_treatplan" /></div>
                    <div class="col-sm-1"><label class="label-def-margin" for="txtexprisk_schedule">Schedule</label></div>
                    <div class="col-sm-3"><input class="form-control" type="text" id="txtexprisk_schedule" /></div>
                </div>
            </div>
            <br />
            <div class="row">
                <div class="col-sm-6">
                    <button type="button" class="btn btn-primary" id="btnSearch">
                        <span class="glyphicon glyphicon-search"></span> Search
                    </button>
                    &nbsp;
                    <button type="button" class="btn btn-primary" id="btnReset">
                        <span class="glyphicon glyphicon-refresh"></span> Reset
                    </button>
                    &nbsp;
                    <button type="button" class="btn btn-primary" title="Download all risk register" id="btnDownload">
                        <span class="fa fa-download"></span> Download Data
                    </button>
                </div>
            </div>
        </div>
    </div>
    <br />

    <div class="row">
        <div class="col-sm-6">
            <button type="button" class="btn btn-primary" id="btnAddRiskRegister" name="btnAddRiskRegister" onclick="@("window.location.href='" + @Url.Action("AddRiskRegister", "RiskRegister") + "'");">
                <span class="glyphicon glyphicon-plus-sign"></span> Add Risk
            </button>
            &nbsp;
            <button type="button" class="btn btn-primary" id="btnSubmitRegister" name="btnSubmitRegister">
                <span class="glyphicon glyphicon-new-window"></span> Submit
            </button>
            &nbsp;
            <button type="button" class="btn btn-primary" id="btnApprove" name="btnApprove">
                <span class="glyphicon glyphicon-new-window"></span> Approve
            </button>
            &nbsp;
            <button type="button" class="btn btn-primary" title="Download all deleted risk register" id="btnDownloadDel">
                <span class="fa fa-download"></span> Download Deleted
            </button>

        </div>
    </div>
    <div class="panel panel-primary">
        <div class="panel-body">
                <table id="tblData" class="table table-striped table-hover table-bordered display nowrap" style="width:100%;font-size: 10px; font-size: 10px; margin-top: 0 !important; margin-bottom: 0 !important; padding-top: 0 !important; padding-bottom: 0 !important;">
                    <thead class="bg-mantle-gradient">
                        <tr>
                            <th style="width: 50px;">Select all <br /> <i class="tblCheck fa fa-square-o" style="cursor:pointer"></i></th>
                            <th style="width: 100px;">Action</th>
                            <th style="width: 50px;">&nbsp;No&nbsp;</th>
                            <th style="width: 150px;">Risk No</th>
                            <th style="width: 100px;">Status</th>
                            <th style="width: 150px;">Department KPI</th>
                            <th style="width: 200px;">Loss Event</th>
                            <th style="width: 200px;">Caused</th>
                            <th style="width: 200px;">Inherent Risk <br /> Notes</th>
                            <th style="width: 100px;">Inherent Risk <br /> Financial Impact</th>
                            <th style="width: 100px;">Inherent Risk <br /> Operation Impact</th>
                            <th style="width: 100px;">Inherent Risk <br /> Strategic Impact</th>
                            <th style="width: 100px;">Inherent Risk <br /> Impact</th>
                            <th style="width: 100px;">Inherent Risk <br /> Likelihood</th>
                            <th style="width: 100px;">Inherent Risk <br /> Overall</th>
                            <th style="width: 200px;">Current Action <br /> Control Description</th>
                            <th style="width: 200px;">Residual Risk <br /> Notes</th>
                            <th style="width: 100px;">Residual Risk <br /> Impact</th>
                            <th style="width: 100px;">Residual Risk <br /> Likelihood</th>
                            <th style="width: 100px;">Residual Risk <br /> Overall</th>
                            <th style="width: 200px;">Expected Risk <br /> Treatment Plan</th>
                            <th style="width: 100px;">Expected Risk <br /> Impact</th>
                            <th style="width: 100px;">Expected Risk <br /> Likelihood</th>
                            <th style="width: 100px;">Expected Risk <br /> Overall</th>
                            <th style="width: 200px;">Expected Risk <br /> Schedule</th>
                            <th style="width: 100px;">Created By</th>
                            <th style="width: 100px;">Created Date</th>


                        </tr>
                    </thead>
                </table>
        </div>
    </div>

    <br />
    <div class="panel panel-primary">
        <div class="panel-heading">
            Upload
        </div>
        <div class="panel-body">
            <div class="row">
                <!--Division-->
                <div class="col-sm-1"><label class="label-def-margin" for="ddlDivision2">Division</label></div>
                <div class="col-sm-3">
                    <select class="form-control" id="ddlDivision2"></select>
                </div>
                <div class="col-sm-1"><label class="label-def-margin" for="ddlDepartment2">Department</label></div>
                <div class="col-sm-3">
                    <select class="form-control" id="ddlDepartment2"></select>
                </div>

            </div>

            <div class="row">
                <div class="control-group col-md-6">
                    <div class="input-group">
                        <input type="text" id="txtriskfile" placeholder="Please select risk register file" class="form-control" readonly>
                        <span class="input-group-btn">
                            <span class="btn btn-primary btn-file">
                                Browse&hellip; <input name="file" id="file" type="file" multiple>
                            </span>
                        </span>
                    </div>
                </div>
                <div class="control-group col-md-6">
                    <button class='btn btn-primary' style="margin-top: 4px" aria-label="riskdownload" id="btnDownloadTemplate"><i class="fa fa-download"></i> Download Template </button>
                    &nbsp;
                    <button class='btn btn-primary' style="margin-top: 4px" aria-label="riskupload" id="btnUpload"><i class="fa fa-upload"></i> Upload</button>
                </div>
            </div>
        </div>
    </div>
</div>
